libpqxx 3.1.1

- Main Page
- Related Pages
- Modules
- Namespaces
- Classes

Namespaces | Classes | Macros | Functions
String conversion

## Namespaces

namespace | pqxx::internal
| Private namespace for libpqxx's internal use; do not access.

## Classes

struct | pqxx::string_traits< T >
| Traits class for use in string conversions. More...
struct | pqxx::string_traits< const char * >
| String traits for C-style string ("pointer to const char") More...
struct | pqxx::string_traits< char * >
| String traits for non-const C-style string ("pointer to char") More...
struct | pqxx::string_traits< char[N]>
| String traits for C-style string constant ("array of char") More...
struct | pqxx::string_traits< std::string >
struct | pqxx::string_traits< const std::string >
struct | pqxx::string_traits< std::stringstream >

## Macros

#define | PQXX_DECLARE_STRING_TRAITS_SPECIALIZATION(T)

## Functions

template<typename T >
void | pqxx::from_string (const char Str[], T &Obj)
| Attempt to convert postgres-generated string to given built-in type.
template<typename T >
void | pqxx::from_string (const char Str[], T &Obj, size_t)
| Conversion with known string length (for strings that may contain nuls)
template<>
void | pqxx::from_string< std::string > (const char Str[], std::string &Obj, size_t len)
template<typename T >
void | pqxx::from_string (const std::string &Str, T &Obj)
template<typename T >
void | pqxx::from_string (const std::stringstream &Str, T &Obj)
template<>
void | pqxx::from_string (const std::string &Str, std::string &Obj)
template<typename T >
std::string | pqxx::to_string (const T &Obj)
| Convert built-in type to a readable string that PostgreSQL will understand.
std::string | pqxx::to_string (const char Obj[])

## Detailed Description

For purposes of communication with the server, values need to be converted from and to a human-readable string format that (unlike the various functions and templates in the C and C++ standard libraries) is not sensitive to locale settings and internationalization. This section contains functionality that is used extensively by libpqxx itself, but is also available for use by other programs.

## Macro Definition Documentation

#define PQXX_DECLARE_STRING_TRAITS_SPECIALIZATION | ( |  | T | ) |

Value:
template<> struct PQXX_LIBEXPORT string_traits<T> \
{ \
typedef T subject_type; \
static const char *name() { return #T; } \
static bool has_null() { return false; } \
static bool is_null(T) { return false; } \
static T null() \
{ internal::throw_null_conversion(name()); return subject_type(); } \
static void from_string(const char Str[], T &Obj); \
static PGSTD::string to_string(T Obj); \
};

## Function Documentation

template<typename T >

void pqxx::from_string | ( | const char | Str[],
|  | T & | Obj
| ) |  |

Attempt to convert postgres-generated string to given built-in type.

If the form of the value found in the string does not match the expected type, e.g. if a decimal point is found when converting to an integer type, the conversion fails. Overflows (e.g. converting "9999999999" to a 16-bit C++ type) are also treated as errors. If in some cases this behaviour should be inappropriate, convert to something bigger such as `long` `int` first and then truncate the resulting value.

Only the simplest possible conversions are supported. No fancy features such as hexadecimal or octal, spurious signs, or exponent notation will work. No whitespace is stripped away. Only the kinds of strings that come out of PostgreSQL and out of to_string() can be converted.

References pqxx::from_string().

template<typename T >

void pqxx::from_string | ( | const char | Str[],
|  | T & | Obj,
|  | size_t |
| ) |  |

Conversion with known string length (for strings that may contain nuls)

This is only used for strings, where embedded nul bytes should not determine the end of the string.

For all other types, this just uses the regular, nul-terminated version of from_string().

References pqxx::from_string().

template<typename T >

void pqxx::from_string | ( | const std::string & | Str,
|  | T & | Obj
| ) |  |

References pqxx::from_string().

template<typename T >

void pqxx::from_string | ( | const std::stringstream & | Str,
|  | T & | Obj
| ) |  |

References pqxx::from_string().

template<>

void pqxx::from_string | ( | const std::string & | Str,
|  | std::string & | Obj
| ) |  |

template<>

void pqxx::from_string< std::string > | ( | const char | Str[],
|  | std::string & | Obj,
|  | size_t | len
| ) |  |

template<typename T >

std::string pqxx::to_string | ( | const T & | Obj | ) |

Convert built-in type to a readable string that PostgreSQL will understand.

No special formatting is done, and any locale settings are ignored. The resulting string will be human-readable and in a format suitable for use in SQL queries.

References pqxx::to_string().

std::string pqxx::to_string | ( | const char | Obj[] | ) |